#include <Wire.h>
#define IR_SENSOR_1 10 // IR sensor pin
#define IR_SENSOR_2 11 // IR sensor pin
#define IR_SENSOR_3 7 // IR sensor pin
#define IR_SENSOR_4 6 // IR sensor pin
#define BUTTON_PIN 9     // Push button pin
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27, 16, 2); // Initialize the LCD for a 16x2 display

unsigned long startTime = 0; // Variable to store the start time
unsigned long elapsedTime = 0; // Variable to store the elapsed time
bool stopwatchRunning = false; // Variable to track the stopwatch state

void setup() {
  lcd.init();         // Initializes the LCD
  lcd.backlight();    // Turns on the backlight
  pinMode(BUTTON_PIN, INPUT_PULLUP); // Push button pin as input with internal pull-up resistor
  pinMode(IR_SENSOR_1, INPUT);     // IR sensor pin as input
  pinMode(IR_SENSOR_2, INPUT);     // IR sensor pin as input
  pinMode(IR_SENSOR_3, INPUT);     // IR sensor pin as inpu
  pinMode(IR_SENSOR_4, INPUT);     // IR sensor pin as inpu
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  lcd.print("GO"); // Initial LCD message
}

void loop() {
  if (!stopwatchRunning) {
    // Display "Press Button" message until the button is pressed
    lcd.setCursor(0, 0);
    lcd.print("      "); // Clear any previous time
    if (digitalRead(BUTTON_PIN) == LOW) {
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("GO"); 
      startTime = millis();
      stopwatchRunning = true;
     
    }
  } else {
    // Calculate elapsed time
    unsigned long currentTime = millis();
    elapsedTime = currentTime - startTime;

    // Display running time
    lcd.setCursor(0, 0);
    lcd.print("Time: ");
    lcd.print(elapsedTime / 1000); // Display seconds
    lcd.print("s ");
    lcd.print(elapsedTime % 1000); // Display milliseconds
    lcd.print("ms");

    if (digitalRead(IR_SENSOR_1) == LOW) {
      // When the IR sensor detects an obstacle, stop the stopwatch
      lcd.setCursor(0, 1);
      lcd.print("FINISH");
      stopwatchRunning = false;
      while (digitalRead(IR_SENSOR_1) == LOW) {
        // Wait until the IR sensor is clear before allowing a new start
        delay(100);
        digitalWrite(2, HIGH);  // turn the LED on (HIGH is the voltage level)
        delay(1000); 
        
      }
    }
    if (digitalRead(IR_SENSOR_2) == LOW) {
      // When the IR sensor detects an obstacle, stop the stopwatch
      lcd.setCursor(0, 1);
      lcd.print("FINISH");
      stopwatchRunning = false;
      while (digitalRead(IR_SENSOR_2) == LOW) {
        // Wait until the IR sensor is clear before allowing a new start
        delay(100);
        digitalWrite(3, HIGH);  // turn the LED on (HIGH is the voltage level)
        delay(1000); 
        
      }
    }
    if (digitalRead(IR_SENSOR_3) == LOW) {
      // When the IR sensor detects an obstacle, stop the stopwatch
      lcd.setCursor(0, 1);
      lcd.print("FINISH");
      stopwatchRunning = false;
      while (digitalRead(IR_SENSOR_3) == LOW) {
        // Wait until the IR sensor is clear before allowing a new start
        delay(100);
        digitalWrite(4, HIGH);  // turn the LED on (HIGH is the voltage level)
        delay(1000); 
        
      }
    }
     if (digitalRead(IR_SENSOR_4) == LOW) {
      // When the IR sensor detects an obstacle, stop the stopwatch
      lcd.setCursor(0, 1);
      lcd.print("FINISH");
      stopwatchRunning = false;
      while (digitalRead(IR_SENSOR_4) == LOW) {
        // Wait until the IR sensor is clear before allowing a new start
        delay(100);
        digitalWrite(5, HIGH);  // turn the LED on (HIGH is the voltage level)
        delay(1000); 
        
      }
    }
  }
}
